#!/bin/bash
#
#    Copyright (C) 2008-2010  Francisco Javier Parra <franparpe@openmailbox.org>
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
#

write_desktop_file(){
    cat << EOF > /usr/share/xsessions/trisquel-compiz-session.desktop
[Desktop Entry]
Name=Trisquel (compiz)
Comment=This session logs you into GNOME with the traditional panel and compiz as the window manager
Exec=gnome-session --session=gnome-compiz
TryExec=gnome-session
Icon=
Type=Application
X-LightDM-DesktopName=GNOME
X-Ubuntu-Gettext-Domain=gnome-panel-3.0
EOF
    echo "/usr/share/xsessions/trisquel-compiz-session.desktop created"
}

write_session_file(){
    cat << EOF > /usr/share/gnome-session/sessions/gnome-compiz.session 
[GNOME Session]
Name=GNOME Compiz
Name[da]=GNOME-compiz
Name[de]=GNOME Compiz
Name[es]=GNOME Compiz
RequiredComponents=gnome-panel;gnome-settings-daemon;gnome-screensaver;compiz;
EOF
    echo "/usr/share/gnome-session/sessions/gnome-compiz.session created"
}

print_both_exists(){
    read -p "Your session is correctly installed, do you want to uninstall it? [y/N]" answer
    if [[ $answer=="y" || $answer=="Y" ]]
    then rm /usr/share/gnome-session/sessions/gnome-compiz.session /usr/share/xsessions/trisquel-compiz-session.desktop
	 echo "Compiz session removed"
    fi
}

print_session_file_exists(){
    echo "It seems to be a problem with the the session."
    echo "What fo you want me to do?"
    echo "1) Install the missing piece"
    echo "2) Remove the session file"
    read -p "Enter your choice [1 - 2] " answer
    case $answer in
	1 ) write_desktop_file;;
	2 ) rm /usr/share/gnome-session/sessions/gnome-compiz.session
	    echo "/usr/share/gnome-session/sessions/gnome-compiz.session removed"
    esac
}

print_desktop_file_exists(){
    echo "It seems to be a problem with the the session."
    echo "What fo you want me to do?"
    echo "1) Install the missing piece"
    echo "2) Remove the desktop file"
    read -p "Enter your choice [1 - 2] " answer
    case $answer in
	1 ) write_session_file;;
	2 ) rm /usr/share/xsessions/trisquel-compiz-session.desktop
	    echo "/usr/share/xsessions/trisquel-compiz-session.desktop removed"
    esac
}

if [[ $EUID -ne 0 ]]; then
    echo "The script must be executed with the sudo command or as root user"
    exit 1
fi

if [ -e /usr/share/xsessions/trisquel-compiz-session.desktop ] && [ -e /usr/share/gnome-session/sessions/gnome-compiz.session ];then
    print_both_exists
    
elif ! [ -e /usr/share/xsessions/trisquel-compiz-session.desktop ] && [ -e /usr/share/gnome-session/sessions/gnome-compiz.session ];then
    print_session_file_exists
    
elif [ -e /usr/share/xsessions/trisquel-compiz-session.desktop ] && ! [ -e /usr/share/gnome-session/sessions/gnome-compiz.session ];then
    print_desktop_file_exists
    
else
    write_session_file
    write_desktop_file
fi
